# Demonstrate synthesizeNTF
using RSDeltaSigmaPort
j=im

#==5th-order modulator
===============================================================================#
println("\t\tNTF Synthesis-- 5th-Order Modulator\n")
OSR = 32

#Basic
NTF5_noopt = synthesizeNTF(5, OSR, opt=0)
plot = plotNTF(NTF5_noopt, OSR, color=:blue)
plot.title = "5th-Order Modulator"
saveimage(:png, "dsdemo1_o5_noopt.png", plot, AR=2/1, width=900)
displaygui(plot)

#Optimized zeros
println("\t\t\tOptimized zeros\n")
NTF5_opt = synthesizeNTF(5, OSR, opt=1)
plot = plotNTF(NTF5_opt, OSR, color=:red)
plot.title = "5th-Order Modulator (Optimized Zeros)"
saveimage(:png, "dsdemo1_o5_zopt.png", plot, AR=2/1, width=900)
displaygui(plot)

#Compare (overlay results)
plot = plotNTF(NTF5_noopt, OSR, color=:blue)
plot = plotNTF!(plot, NTF5_opt, OSR, color=:red)
plot.title = "5th-Order Modulator (Optimized Zeros - Overlay)"
saveimage(:png, "dsdemo1_o5_cmp.png", plot, AR=2/1, width=900)
displaygui(plot)


#==8th-order bandpass modulator
===============================================================================#
println("\t\tNTF Synthesis-- 8th-Order Bandpass Modulator\n")
order = 8
OSR = 64
f0 = 0.125 #fs/8

NTF8bp_opt2 = synthesizeNTF(order, OSR, opt=2, f0=f0)
function gainNTF(order, OSR, NTF)
	G = _zpk(zeros(array_round(order/2)),NTF.p,1,1)
	G.k = 1/abs(evalTF(G,exp(2π*j*f0)))
	return G
end
G = gainNTF(order, OSR, NTF8bp_opt2)
plot = plotNTF(NTF8bp_opt2, OSR, color=:blue, f0=f0, G=G)
plot.title = "8th-Order Bandpass Modulator"
saveimage(:png, "dsdemo1_o8_bp.png", plot, AR=2/1, width=900)
displaygui(plot)

:END_OF_DEMO
